#version 120

varying vec2 TexCoords;

uniform sampler2D colortex0;

vec3 blueColor = vec3(0.0f, 0.56f, 0.768f);
vec3 tealColor = vec3(0.168f, 0.737f, 0.733f);
vec3 greenColor = vec3(0.745f, 0.8f, 0.255f);
vec3 redColor = vec3(0.917f, 0.129f, 0.227f);
vec3 whiteColor = vec3(0.952f, 0.952f, 0.952f);
vec3 blackColor = vec3(0.05f, 0.05f, 0.05f);

float weezDot(vec3 a, vec3 b) {
	return dot(a - b, a - b);
}

void main() {
	vec3 color = texture2D(colortex0, TexCoords).rgb;

	float distToBlue = weezDot(color, blueColor);
	float distToTeal = weezDot(color, tealColor);
	float distToGreen = weezDot(color, greenColor);
	float distToRed = weezDot(color, redColor);
	float distToWhite = weezDot(color, whiteColor);
	float distToBlack = weezDot(color, blackColor);

	vec3 closestColor = blueColor;
	float minDistance = distToBlue;

	if (distToTeal < minDistance) {
		closestColor = tealColor;
		minDistance = distToTeal;
	}
	if (distToGreen < minDistance) {
		closestColor = greenColor;
		minDistance = distToGreen;
	}
	if (distToRed < minDistance) {
		closestColor = redColor;
		minDistance = distToRed;
	}
	if (distToWhite < minDistance) {
		closestColor = whiteColor;
		minDistance = distToWhite;
	}
	if (distToBlack < minDistance * 0.5) {
		closestColor = blackColor;
		minDistance = distToBlack * 0.5;
	}

	gl_FragColor = vec4(closestColor, 1.0f);
}
